(function (global) {
    "use strict";
    //reupload test
    global.ND = global.ND || {};
    global.ND.Portal = global.ND.Portal || {};
    global.ND.Portal.Utilities = (function () {

        var searchForError = function (nameKey, myArray) {
            if (myArray && myArray.Blob) {
                for (var i = 0; i < myArray.Blob.length; i++) {
                    if (myArray.Blob[i].Name["#text"] === nameKey) {
                        return true;
                    }
                }
                if (myArray && !Array.isArray(myArray.Blob)) {
                    if (myArray.Blob.Name["#text"] === nameKey) {
                        return true;
                    }
                }
            }
            return false;
        };

        var formatDate = function (date) {
            if (!date || date === "") {
                return date;
            }
            const monthNames = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
            const day = date.substr(3, 2);
            const month = monthNames[Number(date.substr(0, 2)) - 1];
            const year = date.substr(6, 4);
            return `${month} ${day}, ${year}`;
        };

        var _isOldIE = function (userAgent) {
            var msie = userAgent.indexOf("MSIE");
            var trident = userAgent.indexOf("Trident/");
            if (msie > 0 || trident > 0) {
                return true; // IE 10 or older
            }
            return false; // other browser, IE 11, or Edge
        };

        var showIEWarning = function () {
            if (_isOldIE(navigator.userAgent)) {
                var ieWarning = document.getElementById("ie-banner");
                if (ieWarning) {
                    ieWarning.setAttribute("style", "display: block;");
                }
            }
        };

        var _generateGuid = function () {
            var randomGuid = "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx".replace(/x/g, function (c) {
                var r = (Math.random() * 16) | 0,
                    v = c === "x" ? r : (r & 0x3) | 0x8;
                return v.toString(16);
            });
            return randomGuid;
        };

        var getEntitySetName = (logicalName) => {
            if (!logicalName) {
                return logicalName;
            }
            if (logicalName.endsWith("s")) {
                return logicalName + "es";
            }
            if (logicalName.endsWith("y")) {
                return logicalName + "ies";
            }
            return logicalName + "s";
        };

        var showProgressIndicator = (message) => {
            $("p#progressIndicatorText").text(message || "Loading...");
            $("div#progressIndicator").addClass("visible");
        };

        var hideProgressIndicator = () => {
            $("div#progressIndicator").removeClass("visible");
        };

        var showContextualProgressIndicator = (identifier, message) => {
            $(`#${identifier}LoadingIndicatorText`).text(message || "Loading...");
            $(`#${identifier}LoadingIndicator`).addClass("visible");
        };

        var hideContextualProgressIndicator = (identifier) => {
            $(`#${identifier}LoadingIndicator`).removeClass("visible");
        };

        var createCompositeAddress = (line1, line2, city, state, zip, country) => {
            var addressComponents = [];
            if (line1) {
                addressComponents.push(line1);
            }
            if (line2) {
                addressComponents.push(line2);
            }

            if (city || state || zip) {
                var statezip = `${state} ${zip}`;
                if (city && (state || zip)) {
                    addressComponents.push(`${city}, ${statezip}`);
                }
                else if (city) {
                    addressComponents.push(city);
                }
                else if (state || zip) {
                    addressComponents.push(statezip);
                }
            }

            if (country) {
                addressComponents.push(country);
            }

            if (addressComponents.length === 0) {
                return '&ndash;';
            }

            return addressComponents.join('<br />');
        }

        var toggleFilterBar = (id) => {
            if ($(`#${id}`).hasClass("accordion-expanded")) {
                $(`#${id}`).removeClass("accordion-expanded");
                $(`#${id}-content`).removeClass("visible");
            } else {
                $(`#${id}`).addClass("accordion-expanded")
                $(`#${id}-content`).addClass("visible");
            }
        }

        var openRecord = (path, id) => {
            window.location = `${window.location.origin}/${path}/?id=${id}`;
        }

        var toggleFiltersAccordion = (e) => {

        }

        var getQueryStringParameter = (parameter) => {
            const queryString = window.location.search;
            const urlParams = new URLSearchParams(queryString);
            return urlParams.get(parameter);
        }

        var attachFilterBarEvents = (submitAction = null, submitId = 'submit-btn', resetId = 'reset-btn', callback = null) => {

            $(`#${resetId}`).removeClass('visible');
            $(`#${submitId}`).click(function () {
                var filtersChanged = false;
                $('.form-layout select, .form-layout input').each(function () {
                    if ((this.type === 'text' && $(this).val() !== '')
                        || (this.type !== 'text' && $(this).val() !== $(this).find('option[selected]').val())) {
                        filtersChanged = true;
                        return false;
                    }
                });

                if (filtersChanged) {
                    $(`#${resetId}`).addClass('visible');
                } else {
                    $(`#${resetId}`).removeClass('visible');
                }

                if (submitAction) {
                    submitAction();
                }

                if (callback && callback?.name !== 'resetTableToEmpty') {
                    callback();
                }
            });

            $(`#${resetId}`).click(function () {
                $('.form-layout select, .form-layout input').not("#update-request-modal select, #update-request-modal input").each(function () {
                    $(this).val($(this).find('option[selected]').val())
                });

                $(`#${resetId}`).removeClass('visible');

                if (submitAction && callback?.name !== 'resetTableToEmpty') {
                    submitAction();
                }

                if (callback) {
                    callback();
                }
            });
        }

        var attachMyFilterToggleEvents = (submitAction = null, myId = 'my-records-btn', allId = 'all-records-btn') => {

            $(`#${allId}`).on("click", function () {
                $(`#${myId}`).removeClass("active");
                $(`#${allId}`).addClass("active");

                if (submitAction) {
                    submitAction();
                }
            });

            $(`#${myId}`).on("click", function () {
                $(`#${allId}`).removeClass("active");
                $(`#${myId}`).addClass("active");

                if (submitAction) {
                    submitAction();
                }
            });
        }

        var attachEnterKeyFilterShortcut = (elementName) => {
            $(`#${elementName}-input`).on("keydown", function (e) {
                if (e.key === 'Enter' || e.keyCode === 13) {
                    $(`#${elementName}-btn`).click();
                }
            });
        }

        var getPortalData = () => {
            var data = $("#ndland_portaldata").val();
            return JSON.parse(data || '{}');
        }

        var getPortalDataProperty = (prop, _default = {}) => {
            var data = getPortalData();
            return data[prop] || _default;
        }

        var setPortalData = (value) => {
            $("#ndland_portaldata").val(JSON.stringify(value));
        }

        var setPortalDataProperty = (prop, value) => {
            var data = getPortalData();
            data[prop] = value;
            $("#ndland_portaldata").val(JSON.stringify(data));
        }

        var getSessionStorageValue = (key) => {
            const dataString = sessionStorage.getItem(key);
            return JSON.parse(dataString).value;
        };

        var isSessionStorageKeyActive = (key) => {
            const dataString = sessionStorage.getItem(key);
            if (!dataString) {
                return false; // Key does not exist
            }

            try {
                const data = JSON.parse(dataString);
                const currentTime = Date.now();

                // Check if the current time is less than the expire time
                if (currentTime < data.expire) {
                    return true; // Key has not expired
                } else {
                    // Key has expired, remove it from sessionStorage
                    sessionStorage.removeItem(key);
                    return false; // Key has expired
                }
            } catch (e) {
                console.error('Error parsing sessionStorage data for key:', key, e);
                return false; // In case of error, consider the key as expired
            }
        };

        var saveToSessionStorageWithExpiration = (key, value, expireTime) => {
            const data = {
                value: value,
                expire: expireTime
            };
            sessionStorage.setItem(key, JSON.stringify(data));
        };

        var generateRecordUrl = (record) => {
            var { id, logicalName, type } = { ...record };
            var partilUrl = '';
            var path = '';
            switch (logicalName) {
                case 'eyland_leaseagreement':
                    path = `details`;
                    switch (type) {
                        case 'Mineral':
                            partilUrl = 'mineral-lease-agreements';
                            break;
                        default:
                            partilUrl = 'surface-lease-agreements';
                            break;
                    }
                    break;
                case 'eyland_application':
                    var partilUrl = 'applications';
                    type = type.toUpperCase();
                    switch (type) {
                        case '9378E7ED-479E-EC11-B3FE-001DD8015833': // Coal Lease Nomination
                            path = `coal-lease-nomination`
                            break;
                        case '5B10673B-7A56-EB11-A812-001DD801E994': // Livestock Water Development
                            path = `livestock-water-development`
                            break;
                        case 'CE632F42-479E-EC11-B3FE-001DD8015833': //
                            path = `oil-gas-lease-consent-to-assignment`
                            break;
                        case 'B7B7105B-489E-EC11-B3FE-001DD8015833': //
                            path = `oil-gas-lease-extension`
                            break;
                        case '8BDD1024-479E-EC11-B3FE-001DD8015833': //
                            path = `oil-gas-lease-nomination`
                            break;
                        case '38A35554-4F9E-EC11-B3FE-001DD8015833': //
                            path = `oil-gas-lease-pooling`
                            break;
                        case 'A024AEDE-4B9E-EC11-B3FE-001DD8015833': //
                            path = `oil-and-gas-lease-shut-in`
                            break;
                        case '3BC21D7E-3198-EB11-B1AC-001DD802763F': //
                            path = `permit-prospecting-geophysical`
                            break;
                        case 'FACB6E35-7A56-EB11-A812-001DD801E994': //
                            path = `public-access-sign-post`
                            break;
                        case 'A28961A5-7383-EB11-A812-001DD802F5EB': //
                            path = `right-of-way-amendment`
                            break;
                        case '5179B9AE-EE92-EB11-A812-001DD801CFA8': //
                            path = `right-of-way-consent-to-assignment`
                            break;
                        case 'C999C1A2-EE92-EB11-A812-001DD801CFA8': //
                            path = `right-of-way-easement`
                            break;
                        case 'E26CCEB4-EE92-EB11-A812-001DD801CFA8': //
                            path = `right-of-way-extension-renewal`
                            break;
                        case 'A5F8B9A8-EE92-EB11-A812-001DD801CFA8': //
                            path = `right-of-way-on-lease-use-agreement`
                            break;
                        case '48637097-4A96-EB11-B1AC-001DD802763F': //
                            path = `permit-temporary-infrastructure-construction`
                            break;
                        case '93D12B91-4A96-EB11-B1AC-001DD802763F': //
                            path = `permit-planning-and-preconstruction-survey`
                            break;
                        case '9BF7B2F3-7956-EB11-A812-001DD801E994': //
                            path = `right-of-way-release`
                            break;
                        case '22D799D4-4A96-EB11-B1AC-001DD802763F': //
                            path = `permit-temporary-access`
                            break;
                        case '95C66E35-7A56-EB11-A812-001DD801E994': //
                            path = `surface-lease-assignment`
                            break;
                        case 'BF3EABF9-7956-EB11-A812-001DD801E994': //
                            path = `surface-mineral`
                            break;
                        case '4E182E6B-7A56-EB11-A812-001DD801E994': //
                            path = `weed-and-pest-control-preapproval`
                            break;
                        case '57347E29-7A56-EB11-A812-001DD801E994': //
                            path = `weed-and-pest-control-reimbursement`
                            break;
                    }
                    break;
                case 'eyland_rightofway':
                    partilUrl = 'right-of-way-agreements';
                    path = `details`;
                    break;
            }
            return `${window.location.origin}/${partilUrl}/${path}?id=${id}`;
        }

        var updateMessageBadge = () => {
            var contactid = $('#contactid').attr('data-value');
            if (!contactid) {
                console.log('contact is null');
                return;
            }
            
            ND.Portal.API.appAjax('Retrieving Messages', {
                type: "GET",
                url: `/_api/ndland_portalmessages?$count=true&$select=ndland_portalmessageid&$filter=statuscode eq 769150001 and _ndland_portalcontactid_value eq '{${contactid}}' and ndland_lmsuserid ne null`,
                contentType: "application/json",
                success: function(res, status, xhr) {
                    var unreadCount = res["@odata.count"];
                    var count = $('#messageCount');
                    if (unreadCount > 0) {
                        count.removeClass('hidden');
                    } else {
                        count.addClass('hidden');
                    }
                },
                error: function(xhr, status, error) {
                    var errorMessage = xhr.status + ': ' + xhr.statusText;
                    console.log(errorMessage);
                }
            });
        }

        return {
            searchForError: searchForError,
            showIEWarning: showIEWarning,
            formatDate: formatDate,
            showProgressIndicator: showProgressIndicator,
            hideProgressIndicator: hideProgressIndicator,
            showContextualProgressIndicator: showContextualProgressIndicator,
            hideContextualProgressIndicator: hideContextualProgressIndicator,
            getEntitySetName: getEntitySetName,
            createCompositeAddress: createCompositeAddress,
            toggleFilterBar: toggleFilterBar,
            openRecord: openRecord,
            toggleFiltersAccordion: toggleFiltersAccordion,
            getQueryStringParameter: getQueryStringParameter,
            attachFilterBarEvents: attachFilterBarEvents,
            attachMyFilterToggleEvents: attachMyFilterToggleEvents,
            attachEnterKeyFilterShortcut: attachEnterKeyFilterShortcut,
            getPortalData: getPortalData,
            getPortalDataProperty: getPortalDataProperty,
            setPortalData: setPortalData,
            setPortalDataProperty: setPortalDataProperty,
            getSessionStorageValue: getSessionStorageValue,
            isSessionStorageKeyActive: isSessionStorageKeyActive,
            saveToSessionStorageWithExpiration: saveToSessionStorageWithExpiration,
            generateRecordUrl: generateRecordUrl,
            updateMessageBadge: updateMessageBadge
        };
    })();

    global.ND.Portal.Notification = (function () {
        var $processingMsgEl = $("#processingMsg"),
            _msg = "Processing...",
            _stack = 0,
            _endTimeout;

        var show = function (msg) {
            $processingMsgEl.text(msg || _msg);
            if (_stack === 0) {
                clearTimeout(_endTimeout);
                $processingMsgEl.show();
            }
            _stack++;
        };

        var hide = function () {
            _stack--;
            if (_stack <= 0) {
                _stack = 0;
                clearTimeout(_endTimeout);
                _endTimeout = setTimeout(function () {
                    $processingMsgEl.hide();
                }, 500);
            }
        };

        return {
            show: show,
            hide: hide,
        };
    })();
})(this);

